#define PREFIX 1
#define EXTRACT 2
#define LOCATION 3
#define MAKEINDEX 4
#define GREP 5

#define C_MODE 1 /* compressed */
#define T_MODE 0 /* transparent */

#define DDSCM_NULL -4
#define DDSCM_ON 1
#define DDSCM_OFF 0
#define DDSCM_QUERY -1
#define DDSCM_LOG -2
#define DDSCM_TELL -3

#define DDS2TAR 0
#define DDS2INDEX 1
#define MTDDS 2

/*
 * It's faster to read some records than to skip ovber them,
 * if the number is smaller then DONT_SKIP.
 * I realy don't know the right number here.
 */
#define DONT_SKIP 100

extern char*device_name;
extern int mode ;
extern int dump_mode ;
extern int hash_mode ;
extern int tar_index_file ;
extern int tar_fb ;
extern int tar_bs ;
extern int tar_n ;
extern int device ;
extern int verbose ;
extern FILE *index_fp;
extern char **cmp_list;

#define NREC 64
#define N (512*NREC)
typedef union {
	char chrptr[512] ;
	struct {
		char name[100];
		char dummy1[24];
		char size[12];
		char dummy2[121];
		char magic[8];
	} hdr ;
} tar_record ;

extern int open_device(char*,int,int);
extern FILE *open_file(char*,int,char*);
extern int dds_index(void);
extern int dds_cmp(void);
extern int dds_getpos(void);
extern int dds_seek(int blkno);
